webpackJsonp([16],{

/***/ 2073:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "SettingPageModule", function() { return SettingPageModule; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__setting__ = __webpack_require__(2260);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__directives_directives_module__ = __webpack_require__(15);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};




var SettingPageModule = /** @class */ (function () {
    function SettingPageModule() {
    }
    SettingPageModule = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["NgModule"])({
            declarations: [
                __WEBPACK_IMPORTED_MODULE_2__setting__["a" /* SettingPage */],
            ],
            imports: [
                __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["m" /* IonicPageModule */].forChild(__WEBPACK_IMPORTED_MODULE_2__setting__["a" /* SettingPage */]),
                __WEBPACK_IMPORTED_MODULE_3__directives_directives_module__["a" /* CoreDirectivesModule */]
            ],
        })
    ], SettingPageModule);
    return SettingPageModule;
}());

//# sourceMappingURL=setting.module.js.map

/***/ }),

/***/ 2260:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return SettingPage; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__angular_core__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ionic_angular__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__providers_oucrest_oucrest__ = __webpack_require__(90);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_angular_oauth2_oidc__ = __webpack_require__(218);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__ionic_storage__ = __webpack_require__(131);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__providers_ouclogin_ouclogin__ = __webpack_require__(411);
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/*
 * @Description: In User Settings Edit
 * @Author: your name
 * @Date: 2019-08-07 09:16:40
 * @LastEditTime: 2019-11-04 10:15:38
 * @LastEditors: Please set LastEditors
 */






/**
 * Generated class for the SettingPage page.
 *
 * See https://ionicframework.com/docs/components/#navigation for more info on
 * Ionic pages and navigation.
 */
var SettingPage = /** @class */ (function () {
    function SettingPage(navCtrl, navParams, oucloginProvider, rest, oauthService, storage, events, viewCtrl) {
        var _this = this;
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.oucloginProvider = oucloginProvider;
        this.rest = rest;
        this.oauthService = oauthService;
        this.storage = storage;
        this.events = events;
        this.viewCtrl = viewCtrl;
        this.studenturl = 'http://117.78.41.66:9005/api/Student';
        this.teacherUrl = 'http://117.78.41.66:9010/api/Teacher';
        this.userinfoUrl = 'http://passport.ouchn.cn/connect/userinfo'; // 学生信息地址
        this.studentInfo = {
            Name: '',
            Birthday: '',
        };
        events.subscribe('reLogin', function (name) {
            _this.ionViewWillEnter();
        });
    }
    SettingPage.prototype.ngOnInit = function () {
    };
    SettingPage.prototype.ionViewWillEnter = function () {
        var _this = this;
        this.storage.get('oucAccessToken').then(function (value) {
            if (value != null) {
                _this.rest.httpGet(value, _this.userinfoUrl, '', function (user) {
                    if (user.UserType == 2) {
                        _this.rest.httpGet(value, _this.studenturl, '', function (d) {
                            _this.studentInfo = d.Data;
                            if (d.Data.Gender == 1) {
                                _this.genner = "男";
                            }
                            else if (d.Data.Gender == 2) {
                                _this.genner = "女";
                            }
                            else {
                                _this.genner = "未知";
                            }
                        }, false);
                    }
                    if (user.UserType == 1) {
                        _this.rest.httpGet(value, _this.teacherUrl, '', function (d) {
                            _this.studentInfo = d.Data;
                            if (d.Data.Gender == 1) {
                                _this.genner = "男";
                            }
                            else if (d.Data.Gender == 2) {
                                _this.genner = "女";
                            }
                            else {
                                _this.genner = "未知";
                            }
                        }, false);
                    }
                });
            }
            else {
                _this.studentInfo.Name = '';
                _this.genner = '';
                _this.oucloginProvider.redirectLogin().then(function (success) {
                    _this.storage.set('oucAccessToken', success);
                    _this.ionViewWillEnter();
                }, function (error) {
                });
            }
        });
    };
    SettingPage.prototype.gotoPassword = function () {
        this.navCtrl.push('PasswordPage');
    };
    SettingPage.prototype.logout = function () {
        var _this = this;
        this.storage.get('oucAccessToken').then(function (value) {
            if (value != null) {
                _this.storage.set('refreshOucAccessToken', null);
                _this.storage.set('oucAccessToken', null);
                _this.viewCtrl.dismiss();
                // this.storage.remove('oucAccessToken').then((outvalue) => {
                //   this.studentInfo.Name='';
                //   this.genner='';
                //   this.rest.toast('退出成功，请重新登录');
                //   this.oucloginProvider.redirectLogin().then(success => {
                //     this.storage.set('oucAccessToken', success);
                //     this.viewCtrl.dismiss();
                //   },(error) =>{
                //   });
                // });
            }
            else {
            }
        });
    };
    SettingPage = __decorate([
        Object(__WEBPACK_IMPORTED_MODULE_0__angular_core__["Component"])({
            selector: 'page-setting',template:/*ion-inline-start:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\pages\setting\setting.html"*/'<!--\n  Generated template for the SettingPage page.\n\n  See http://ionicframework.com/docs/components/#navigation for more info on\n  Ionic pages and navigation.\n-->\n<ion-header>\n  <ion-navbar core-back-button>\n    <ion-title text-center>账户设置</ion-title>\n  </ion-navbar>\n</ion-header>\n<!-- 头像 -->\n<ion-content>\n  <button class="bottom-line" ion-item (click)="gotoSetting()">\n    <ion-label item-start>头像</ion-label>\n    <ion-avatar item-end>\n      <img src="assets/ouc/defult-icon.png">\n    </ion-avatar>\n  </button>\n\n<!-- 昵称 -->\n\n  <button class="bottom-line" ion-item (click)="gotoSetting()">\n    <ion-label item-start>昵称</ion-label>\n    <ion-label text-right item-end>{{studentInfo.Name!}}</ion-label>\n  </button>\n\n  <!-- 手机号码 -->\n\n  <button *ngIf="false" class="bottom-line" ion-item (click)="gotoSetting()">\n    <ion-label item-start>手机号码</ion-label>\n    <ion-label text-right item-end>18810034628</ion-label>\n  </button>\n\n  \n\n  <!-- QQ号 -->\n\n  <button  class="bottom-line" ion-item (click)="gotoSetting()">\n    <ion-label item-start>性别</ion-label>\n    <ion-label text-right item-end>{{genner}}</ion-label>\n  </button>\n\n  <!-- 邮寄地址 -->\n\n  <button hidden class="bottom-line" ion-item (click)="gotoSetting()">\n    <ion-label item-start>邮寄地址</ion-label>\n    <ion-label text-right item-end>昵称</ion-label>\n  </button>\n\n   <!-- 所在单位 -->\n\n   <button hidden class="bottom-line" ion-item (click)="gotoSetting()">\n    <ion-label item-start>所在单位</ion-label>\n    <ion-label text-right item-end>昵称</ion-label>\n  </button>\n\n    <!-- 修改密码 -->\n\n    <button hidden class="bottom-line" ion-item (click)="gotoPassword()">\n      <ion-label item-start>修改密码</ion-label>\n    </button> \n\n    <!-- 退出登录 -->\n    <button class="bottom-line" ion-item (click)="logout()">\n      <ion-label item-start>退出登录</ion-label>\n    </button> \n</ion-content>\n '/*ion-inline-end:"F:\guokaizaixian\baoliwei\moodlemobile2-master\src\pages\setting\setting.html"*/,
        }),
        __metadata("design:paramtypes", [__WEBPACK_IMPORTED_MODULE_1_ionic_angular__["t" /* NavController */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["u" /* NavParams */], __WEBPACK_IMPORTED_MODULE_5__providers_ouclogin_ouclogin__["a" /* OucloginProvider */],
            __WEBPACK_IMPORTED_MODULE_2__providers_oucrest_oucrest__["a" /* OucrestProvider */], __WEBPACK_IMPORTED_MODULE_3_angular_oauth2_oidc__["b" /* OAuthService */], __WEBPACK_IMPORTED_MODULE_4__ionic_storage__["b" /* Storage */], __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["i" /* Events */],
            __WEBPACK_IMPORTED_MODULE_1_ionic_angular__["F" /* ViewController */]])
    ], SettingPage);
    return SettingPage;
}());

//# sourceMappingURL=setting.js.map

/***/ })

});
//# sourceMappingURL=16.js.map